﻿Imports System.ComponentModel ' Wird für die Kategorisierung der neuen Eigenschaften benötigt. Ohne diese Zeile bekommen wir in den Zeilen <Category> eine Fehlermeldung

Imports System.Runtime.InteropServices ' Zugriff auf die DLL ermöglichen

<Microsoft.VisualBasic.ComClass()>
Public Class TestDLL



    ' OT MS: Bewirkt, dass die aktuelle Klasse oder Schnittstelle die Attribute, Variablen, Eigenschaften, Prozeduren und Ereignisse von einer
    ' anderen Klasse oder Gruppe von Schnittstellen erbt.
    ' Dies bedeut also, dass man die Eigenschaften, die bei allen hier verwendeten Steuerelemten gleich sind, auch direkt nutzen kann.
    ' Diese Eigenschaften müssen alle nicht extra eingebaut werden, sondern werden "durchgeschleift" und an alle Steuerelemente dieses Controls weitergeleitet.
    ' Es sind also nur neue Aktionen hinzuzufügen, die es noch nicht gibt bzw. bei denen etwas anderes passieren soll.
    ' Multiline bspw. gibt es bei der Textbox, aber nicht bei der Picturebox. Also muss diese Eigenschaft wieder eingebaut werden und auch die Ansteuerung der Textbox muss erfolgen.
    Inherits UserControl ' Nimmt uns schon einmal sehr viel Arbeit ab. 

    ' Hier werden die Aufrufe für die ggf. einzelnen Aktionen deklariert
    Public Event Standard_Aktion_ausfuehren As EventHandler

    Sub New()
        ' ****************************************************************
        ' Hier werden ein paar Grundeinstellungen für die neuen Eigenschaften festgelegt,
        ' sobald das neue Steuerelement in die Hauptform eingefügt wird
        ' ****************************************************************

        ' Dieser Aufruf ist für den Designer erforderlich.
        InitializeComponent()

        My.Settings.Checked = True
        My.Settings.Save()

        ' Wenn der Checked-Wert auf False steht,
        If My.Settings.Checked = False Then

            ' dann die passende Grafik für Aus anzeigen
            PBox_Button.BackgroundImage = My.Resources.ResourceManager.GetObject("Grafik_01_Aus")

        Else

            ' andernfalls für Ein
            PBox_Button.BackgroundImage = My.Resources.ResourceManager.GetObject("Grafik_01_Ein")

        End If

    End Sub

    ' Ein Versuch, dass die Grafik richtig beim neuzeichnen angezeigt wird.
    Shadows Sub paint()

        ' Wenn der Checked-Wert auf False steht,
        If My.Settings.Checked = False Then

            ' dann die passende Grafik für Aus anzeigen
            PBox_Button.BackgroundImage = My.Resources.ResourceManager.GetObject("Grafik_01_Aus")

        Else

            ' andernfalls für Ein
            PBox_Button.BackgroundImage = My.Resources.ResourceManager.GetObject("Grafik_01_Ein")

        End If

    End Sub
#Region "Neue Eigenschaften"
    ' *************************************************************************
    ' Die nachfolgenden Zeilen stellen die sichtbaren neuen Eigenschaften dar.
    ' *************************************************************************

    ' Über <Category ...> kann man für jede folgende neue Eigenschaft eine bestehende oder neue Kategorie festlegen, unter der dann diese Eigenschaft zu finden ist.
    ' Ich habe mich hier für eine durch den Buchstaben A anfangne Kategorie entschieden. Dadurch stehen die neuen Eigenschaften ganz oben. Lässt man die Zeile weg, so gibt es eine Kategorie 'Sonstige'
    ' Da die folgenden Eigenschaften immer gleich aufgebaut sind, habe ich mir die Beschriftung nur in die erste eingetragen.

    <Category("Alternative Eigenschaften")>
    <System.Runtime.InteropServices.ComVisible(True)>
    Public Property Checked As Boolean

        ' Wenn der Wert der Eigenschaft zurück gegeben werden soll,
        Get

            ' dann wird hier der aktuelle Wert zurück gegeben
            Return My.Settings.Checked

        End Get

        ' Soll er hingegen geändert werden,
        Set(value As Boolean)

            ' dann bekommt die interne Variable den aktuellen Wert erst einmal zugewiesen
            My.Settings.Checked = value
            My.Settings.Save()

            ' und danach wird die ggf. notwendige Aktion aufgerufen
            RaiseEvent Standard_Aktion_ausfuehren(Me, EventArgs.Empty)

        End Set

    End Property

#End Region

#Region "und die neuen Aktionen"

    Private Sub HandleStandard_Aktion_ausfuehren(sender As Object, e As EventArgs) Handles Me.Standard_Aktion_ausfuehren
        ' ****************************************************************
        ' Hier wird auf Änderungen der Eigenschaft reagieren
        ' ****************************************************************

        ' Aufgrund der neuen Einstellung wird die Anzeige der Grafik bzw. der Textbox neu durchgeführt
        ' Hier kommen also alle Aktionen hin, die dann auf die aktuellen Einstellungen der Eigenschaften reagieren.

        ' Wenn der Checked-Wert auf False steht,
        If My.Settings.Checked = False Then

            ' dann die passende Grafik für Aus anzeigen
            PBox_Button.BackgroundImage = My.Resources.ResourceManager.GetObject("Grafik_01_Aus")

        Else

            ' andernfalls für Ein
            PBox_Button.BackgroundImage = My.Resources.ResourceManager.GetObject("Grafik_01_Ein")

        End If

    End Sub

    ' Hier mal die drei Möglichkeiten, später die Umschaltung von dem Wert Checked vorzunehmen
    Private Sub PBox_Button_Click(sender As Object, e As EventArgs) Handles PBox_Button.Click
        If Checked = True Then
            Checked = False
        Else
            Checked = True
        End If
    End Sub

    Private Sub TestDLL_Click(sender As Object, e As EventArgs) Handles Me.Click
        If Checked = True Then
            Checked = False
        Else
            Checked = True
        End If
    End Sub

    Private Sub TextBox1_Click(sender As Object, e As EventArgs) Handles TextBox1.Click
        If Checked = True Then
            Checked = False
        Else
            Checked = True
        End If
    End Sub

#End Region

End Class
